package org.pnml.tools.epnk.gmf.integration.advices;

import java.util.Collections;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.commands.core.command.AbstractTransactionalCommand;
import org.pnml.tools.epnk.pnmlcoremodel.LabelProxy;
import org.pnml.tools.epnk.pnmlcoremodel.Object;

// @generated NOT
// @author eki
public class DetachLabelProxies extends AbstractTransactionalCommand {

	private Object object;
	
	public DetachLabelProxies(Object object) { 
		super(TransactionUtil.getEditingDomain(object),
				"Detach objects label proxies",
				Collections.singletonList(WorkspaceSynchronizer.getFile(object.eResource())));
		this.object = object;
	}

	@Override
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (object == null) {
			return CommandResult.newErrorCommandResult("Invalid input");
		}
		 
		/*
        EList<LabelProxy> list =  object.getLabelproxy();
        while (list.size() > 0) {
        	LabelProxy proxy = list.get(0);
        	proxy.setLabel(null);
        	list.remove(0);
        }
        */
       
	    detachLabels(object);
        // TODO: eventually, we should also detach the labels of
	    //       the attached arcs; but this would require a change
	    //       of the model (which will be needed anyway eventually):
	    //       out and in features from nodes to their arcs (transient).

		return CommandResult.newOKCommandResult();
	}
	
	private void detachLabels(Object object) {
		for (LabelProxy proxy: object.getLabelproxy()) {
			if (proxy.getLabel() != null) {
				proxy.setLabel(null);
			}
		}
	}

}
