package org.pnml.tools.epnk.helpers;

import java.util.List;
import java.util.Vector;

import org.eclipse.emf.ecore.EObject;
import org.pnml.tools.epnk.pnmlcoremodel.Page;
import org.pnml.tools.epnk.pnmlcoremodel.PetriNet;
import org.pnml.tools.epnk.pnmlcoremodel.PetriNetType;
import org.pnml.tools.epnk.pnmlcoremodel.Object;

/** 
 * This class implements some helper methods for calculating properties
 * on nets and its elements.
 * 
 * @author kindler
 * @generated NOT
 *
 */
public class NetFunctions {
	
	public static PetriNet getPetriNet(EObject object) {
		// TODO this should be done a bit more defensively (only for
		//      Petri net elements.
		EObject o = object;
		
		while (o != null && !(o instanceof PetriNet) && o.eContainer() !=  null) {
			o = o.eContainer();
		}
		
		if (o instanceof PetriNet) {
			return (PetriNet) o;
		} else {
			return null;
		}	
	}
	
	public static PetriNetType getPetriNetType(EObject object) {
		PetriNet pn = getPetriNet(object);
		
		if (pn != null) {
			return pn.getType();
		}
		
		return null;
	}
	
	public static List<Object> getAllNetObjects(PetriNet net) {
		List<Object> list = new Vector<Object>();
		
		for (Page p:net.getPage()) {
			list.add(p);
			list.addAll(getAllPageObjects(p));
		}
		return list;
	}
	
	public static List<Object> getAllPageObjects(Page page) {
		List<Object> list = new Vector<Object>();
		
		for (Object object:page.getObject()) {
			list.add(object);
			if (object instanceof Page) {
				Page p = (Page) object;
				list.addAll(getAllPageObjects(p));
			}
		}	
		return list;	
	}
}
